(* Modulo principal de la aplicacion. Aqui se realizan los procedimientos    *)
(* de comunicacion con el usuario como pintar en pantalla,leer de teclado... *)

MODULE Hiper;

FROM MBolsa IMPORT Terror,TCadena,MAXCAD,TElemento,TBolsa,CrearBolsa,BolsaVacia,BolsaLlena,MeterBolsa,SacarBolsa,DestruirBolsa;
FROM IO IMPORT WrStr,RdStr,WrCard,RdCard,WrChar,RdChar,RdKey,WrLn,RdLn;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM Window IMPORT Clear;
FROM Lib IMPORT Delay;
IMPORT FIO;

TYPE
    TSeparadores= SET OF CHAR;

(* Procedimiento de pausa para parar la pantalla *)

PROCEDURE pausa();
VAR
	x:CHAR;
BEGIN
	WrLn;
	WrStr("Pulsa una tecla para continuar....");
	x:=RdKey();
END pausa;

(* Procedimiento del menu. Muestra el menu en pantalla y lee una entrada *)
(* hasta que sea valida                                                 *)

PROCEDURE menu():CHAR;
VAR
	opcion:CHAR;
	bien:BOOLEAN;
BEGIN
    Clear;
    RdLn;
    REPEAT
    	bien:=FALSE;
    	WrStr("                 Programa realizado por: ??? ???, ???");WrLn;
    	WrStr("                                   Especialidad: SISTEMAS");WrLn;
    	WrStr("                                          Grupo: B");WrLn;
    	WrStr("                                        Maquina: 123");WrLn;WrLn;
    	WrStr("                          HiperMod");WrLn;
    	WrStr("                          ========");WrLn;WrLn;
    	WrStr("      A. Introducir producto en la bolsa.");WrLn;
    	WrStr("      B. Mostrar el contenido de la bolsa.");WrLn;
    	WrStr("      C. Sacar un producto de la bolsa.");WrLn;
    	WrStr("      D. Imprimir Ticket");WrLn;
    	WrStr("      E. Compra por Internet");WrLn;
    	WrStr("      X. Salir del programa.");WrLn;WrLn;WrLn;WrLn;
    	WrStr(" Selecciona una opcin: ");
    	opcion:=CAP(RdChar());
    	IF (opcion<'A') OR (opcion>'E') OR (opcion<>'X') THEN
        	bien:=TRUE;
        ELSE
        	bien:=FALSE;
        END;
    UNTIL bien;
    RETURN opcion;
END menu;



(* lee un  producto desde teclado y lo guarda en una variable       *)
(* del tipo Telemento                                               *)

PROCEDURE leeprod(VAR e:TElemento);
BEGIN	
	Clear;
	WrStr("           ͻ");WrLn;
	WrStr("               INTRODUCIR UN PRODUCTO EN LA BOLSA    ");WrLn;
	WrStr("           ͼ");WrLn;
	WrLn;WrLn;
	WrStr(" Referencia: ");
	e.referencia:=RdCard();
	WrStr(" Nombre del producto: ");
	RdStr(e.producto);
END leeprod;

(* escribe un producto en pantalla *)

PROCEDURE pintarprod(e:TElemento);
BEGIN
	Clear;
	WrStr("           ͻ");WrLn;
	WrStr("                     INFORMACION DE PRODUCTO         ");WrLn;
	WrStr("           ͼ");WrLn;
	WrLn;WrLn;
	WrStr("  Referencia: ");
	WrCard(e.referencia,0);WrLn;
	WrStr("    Producto: ");
	WrStr(e.producto);WrLn;
	pausa;
END pintarprod;



(* procedimiento que muestra la pantalla para sacar un elemento de la bolsa *)

PROCEDURE sacar(VAR n:CARDINAL);
VAR
	ptr:TBolsa;
BEGIN
	Clear;
	WrStr("           ͻ");WrLn;
	WrStr("                  SACAR UN PRODUCTO DE LA BOLSA      ");WrLn;
	WrStr("           ͼ");WrLn;
	WrLn;WrLn;
	WrStr("  Referencia: ");
	n:=RdCard();
END sacar;

(* procedimiento para salir *)

PROCEDURE sal():BOOLEAN;
VAR
	x:CHAR;
BEGIN
	Clear;
	WrLn;WrLn;WrLn;WrLn;WrLn;WrLn;
	WrStr("                     Estas seguro de querer salir (S/N): ");
	x:=CAP(RdKey());
	IF x='S' THEN
		RETURN TRUE;
	ELSE
		RETURN FALSE;
	END;
END sal;
	



PROCEDURE msgcritico(cad:ARRAY OF CHAR);
BEGIN
	Clear;
	WrLn;WrLn;WrLn;WrLn;WrLn;WrLn;
	
	WrStr(cad);
	WrLn;WrLn;WrLn;WrLn;WrLn;WrLn;
	pausa;
END msgcritico;


(* comprueba que hay espacio disponible *)

PROCEDURE disponible():BOOLEAN;
BEGIN
	IF Available(SIZE(TElemento)) THEN
		RETURN TRUE;
	ELSE
		RETURN FALSE;
	END;
END disponible;


PROCEDURE mostrarbolsa(VAR b:TBolsa;VAR error:Terror);
VAR
	vacia:BOOLEAN;
	ptr:TBolsa;
	e:TElemento;
	
BEGIN
	ptr:=CrearBolsa();
	error:=bien;
	IF BolsaVacia(b) THEN
		msgcritico("                            La bolsa esta vacia ");
	ELSE
		WHILE NOT (BolsaVacia(b)) DO		
				SacarBolsa(b,e,error);
				pintarprod(e);
				MeterBolsa(ptr,e,error);
		END;
	    WHILE NOT (BolsaVacia(ptr)) DO
				SacarBolsa(ptr,e,error);
				MeterBolsa(b,e,error);
		END;
	END;
    DestruirBolsa(ptr);			
END mostrarbolsa;

PROCEDURE sacadelabolsa(VAR b:TBolsa;n:CARDINAL;VAR error:Terror);
VAR
	ptr:TBolsa;
	e:TElemento;
	encontrado:BOOLEAN;
BEGIN
        error:=bien;
	ptr:=CrearBolsa();
	encontrado:=FALSE;
	WHILE (NOT BolsaVacia(b)) AND (NOT encontrado) DO
        	SacarBolsa(b,e,error);
		IF e.referencia<>n THEN
                   MeterBolsa(ptr,e,error);
		ELSE
		   encontrado:=TRUE;
		END;
	END;
	WHILE NOT BolsaVacia(ptr) DO
        	SacarBolsa(ptr,e,error);
        	MeterBolsa(b,e,error);
	END;
	DestruirBolsa(ptr);	
	IF NOT encontrado THEN
	  error:=nohay
	END;
END sacadelabolsa;

(* EL SIGUIENTE PROCEDIMIENTO BUSCA EL PRECIO DE UNA PRODUCTO
   EN EL FICHERO DE PRECIOS. LA BUSQUEDA SE REALIZA PARTIR DE LA
   REFERENCIA DEL PRODUCTO *)

PROCEDURE leeprecio(n:CARDINAL;archivo:TCadena):CARDINAL;
VAR
	precio,aux,bas:CARDINAL;
	f:FIO.File;
	cad:TCadena;
	fin:BOOLEAN;
BEGIN
	fin:=FALSE;
	precio:=0;
	f:=FIO.OpenRead(archivo);
	
	   (* OJO a la LECTURA ADELANTADA. FUNDAMENTAL !! *)
	
	aux:=FIO.RdCard(f);
	WHILE (NOT FIO.EOF) AND (NOT fin) DO
		IF aux=n THEN
			precio:=FIO.RdCard(f);;
			fin:=TRUE;
		ELSE
	        bas:=FIO.RdCard(f);
		END;
		aux:=FIO.RdCard(f);	
	END;
	FIO.Close(f);
	RETURN precio;
END leeprecio;


(* imprime el ticket. *)


PROCEDURE imprime(VAR b:TBolsa;VAR error:Terror):CARDINAL;	
VAR
	suma,precio:CARDINAL;	
	e:TElemento;
	vacia:BOOLEAN;
BEGIN
	vacia:=FALSE;
	suma:=0;
	error:=bien;
	vacia:=BolsaVacia(b);
	IF vacia THEN
		error:=nohay;
		RETURN 0;
	ELSE
	    Clear;
	    WrStr("           ͻ");WrLn;
		WrStr("                        TOTAL DE LA COMPRA            ");WrLn;
		WrStr("           ͼ");WrLn;
		WrLn;WrLn;
		WHILE (NOT vacia) DO
			precio:=0;
			SacarBolsa(b,e,error);
			precio:=leeprecio(e.referencia,'PVP.TXT');
			IF precio <>0 THEN
				WrStr("   Referencia: ");WrCard(e.referencia,0);WrStr("      Articulo: ");WrStr(e.producto);
				WrLn;WrStr("               Precio: ");WrCard(precio,0);WrLn;WrLn;
				suma:=suma+precio;
			ELSE
				WrLn;WrLn;
				WrStr("            EL ARTICULO ");WrStr(e.producto);WrStr(" CON LA REFERENCIA ");WrCard(e.referencia,0);WrLn;
				WrStr("              NO SE ENCUENTRA EN LA TABLA DE REFERENCIAS");
				WrLn;WrLn;
			END;
			vacia:=BolsaVacia(b);
		END;
    	RETURN suma;
    END;

END imprime;

PROCEDURE leefile(f:FIO.File):TCadena;
	VAR
	    cad:TCadena;
	    c:CHAR;
	    i:CARDINAL;
	BEGIN
            c:=FIO.RdChar(f);
	    i:= 1;
	    			
	    WHILE ( i <= MAXCAD) AND (c<>FIO.EOL) AND ( c<>'#' ) DO
			cad[i]:=c;
			INC(i);
			c:=FIO.RdChar(f);
	    END;
	    IF i <= MAXCAD THEN
			cad[i]:=CHR(0);		
	    END;
	    RETURN(cad);
END leefile;



PROCEDURE solicitafichero(VAR b:TBolsa;VAR error:Terror);
VAR
	f:FIO.File;
	cad:TCadena;
	e:TElemento;
	i:CARDINAL;
BEGIN
	Clear;
	WrStr("           ͻ");WrLn;
	WrStr("             SOLICITUD DE DATOS PARA LA COMPRA ONLINE  ");WrLn;
	WrStr("           ͼ");WrLn;
	WrLn;WrLn;
	WrStr("Introduce el nombre del archivo: ");
	RdStr(cad);
	error:=bien;
	IF FIO.Exists(cad) THEN	
		WrStr("Cargando productos");
		FOR i:=1 TO 10 DO
			WrChar(".");
			Delay(150);
		END;
		WrLn;
		f:=FIO.OpenRead(cad);
		WHILE NOT FIO.EOF DO
			e.producto:=leefile(f);
			e.referencia:=FIO.RdCard(f);
			MeterBolsa(b,e,error);
		END;
		FIO.Close(f);
		WrLn;
	ELSE
		error:=nohay;
	END;					
END solicitafichero;

(*Se deberia imprimir exactamente lo mismo
   que en la pantalla. Asi que habria que completar este procedimiento *)

PROCEDURE daticket(VAR b:TBolsa;error:Terror);
VAR
	f:FIO.File;
	e:TElemento;
	vacia:BOOLEAN;
	precio,suma:CARDINAL;
BEGIN
	suma:=0;
	f:=FIO.Create("TICKET.OUT");
	error:=bien;
	vacia:=BolsaVacia(b);
	IF NOT vacia THEN
		Clear;
		WrStr("           ͻ");WrLn;
		WrStr("              TICKET DE COMPRA A TRAVES DE INTERNET   ");WrLn;
		WrStr("           ͼ");WrLn;
		WrLn;WrLn;
	END;
	
	WHILE NOT vacia DO
		SacarBolsa(b,e,error);
		WrStr("   Referencia: ");WrCard(e.referencia,0);WrStr("      Articulo: ");WrStr(e.producto);
		
		precio:=leeprecio(e.referencia,'PVP.TXT');
		WrLn;WrStr("               Precio: ");WrCard(precio,0);WrLn;WrLn;
		FIO.WrCard(f,e.referencia,0);
		FIO.WrLn(f);
		FIO.WrStr(f,e.producto);
		FIO.WrLn(f);
		FIO.WrCard(f,precio,0);
		suma:=suma+precio;
		FIO.WrLn(f);
		vacia:=BolsaVacia(b);
	END;
	WrLn;WrLn;
	WrStr("       TOTAL DE LA COMPRA: ");WrCard(suma,0);WrStr(" Pesetas");
	
	
	FIO.Close(f);
END daticket;
		

(* declaracion de variables  *)

VAR
	bolsa,aux:TBolsa;
	elem:TElemento;
	salida,ok:BOOLEAN;
	eleccion:CHAR;
	error:Terror;
	ref,total,tmp:CARDINAL;
BEGIN
	
	Clear;
	RdLn;
	salida:=FALSE;
	bolsa:=CrearBolsa();
	aux:=CrearBolsa();
	REPEAT
		eleccion:=menu();
			CASE eleccion OF
			
				'A' :   leeprod(elem);
						ok:=disponible();
						IF ok THEN
							MeterBolsa(bolsa,elem,error);
							IF error=bien THEN
								msgcritico("                  La operacion se ha realizado con exito");
							ELSIF error=memoria THEN
								msgcritico("                        No hay memoria disponible");
							END;
						ELSE
							msgcritico("                               No hay memoria disponible");
						END;
						|
				'B' :	mostrarbolsa(bolsa,error);
						IF error=memoria THEN
							msgcritico("        NO hubo memoria disponible para realizar la operacion");
						ELSIF error=nohay THEN
							msgcritico("	La bolsa no contiene el elemento (quizas este vacia)");
						END;
						|
						
				'C' : 	ok:=BolsaVacia(bolsa);
						IF ok THEN
							msgcritico("                            La bolsa esta vacia");
						ELSE
							sacar(ref);
							sacadelabolsa(bolsa,ref,error);
							IF error=bien THEN
								msgcritico("            Se elimino el elemento solicitado de la bolsa");
							ELSIF error=nohay THEN
								msgcritico("            No se ha encontrado el elemento en la bolsa");
							END;
						END;	
						|
				'D' :
						total:=imprime(bolsa,error);
						IF error=nohay THEN
							msgcritico("                        No hay nada en la bolsa");
						ELSE
							WrLn;
							WrStr(" Total de la compra: ");WrCard(total,0);pausa;
						END;
						|
				'E' :   solicitafichero(bolsa,error);
						IF error=bien THEN
							daticket(bolsa,error);
						ELSIF error=nohay THEN
							msgcritico("                     El fichero especificado no existe");
						END;
						pausa;|
				'X' :   salida:=sal();
			END;
	UNTIL salida;
	DestruirBolsa(bolsa);
    Clear;

END Hiper.