IMPLEMENTATION MODULE MBolsa;

FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;

TYPE
	TBolsa=POINTER TO Pbolsa;
	Pbolsa=RECORD
		data:TElemento;
		sig:TBolsa;
		END;

(* !OJO! Los siguientes procedimientos de manejo de cadenas
   habria que hacerlos con ARRAYS ABIERTOS *)
	
PROCEDURE longitud(cad:TCadena):CARDINAL;
VAR
	x:CARDINAL;
BEGIN
	x:=1;
	WHILE cad[x]<> FINCAD DO
		INC (x);
	END;
	RETURN x;
END longitud;

PROCEDURE comparar(cad1,cad2:TCadena):BOOLEAN;
VAR
	l1,l2,cont:CARDINAL;
	ok:BOOLEAN;
BEGIN
	l1:=longitud(cad1);
	l2:=longitud(cad2);
	IF l1<>l2 THEN
		ok:=FALSE;
	ELSE
		cont:=0;
		WHILE (CAP(cad1[cont])=CAP(cad2[cont])) AND (cont<=l1) DO
			INC (cont);
		END;
		cont:=cont-1;
	    IF l1=cont THEN
	    	ok:=TRUE;
	    ELSE
	    	ok:=FALSE;
	    END;
	END;
	RETURN ok;
END comparar;



PROCEDURE CrearBolsa():TBolsa;
BEGIN
	RETURN NIL;
END CrearBolsa;



PROCEDURE BolsaVacia(b:TBolsa):BOOLEAN;
BEGIN
	RETURN (b= NIL)
END BolsaVacia;



	
PROCEDURE BolsaLlena(b:TBolsa):BOOLEAN;
BEGIN
	RETURN NOT Available(SIZE(TElemento))
END BolsaLlena;


PROCEDURE MeterBolsa(VAR b:TBolsa; e:TElemento;VAR error:Terror);
VAR
	ptr:TBolsa;
	llena:BOOLEAN;
BEGIN
	llena:=BolsaLlena(b);
	IF (NOT llena) THEN
		NEW(ptr);
		ptr^.data:=e;
		ptr^.sig:=b;
		b:=ptr;
		error:=bien;
	ELSE
		error:=memoria;
	END;
END MeterBolsa;


PROCEDURE SacarBolsa(VAR b:TBolsa;VAR e:TElemento;VAR error:Terror);
VAR
	ptr:TBolsa;
	vacia:BOOLEAN;
BEGIN
	vacia:=BolsaVacia(b);
	IF NOT vacia THEN
		e:=b^.data;
		ptr:=b;
		b:=b^.sig;
		DISPOSE (ptr);
		error:=bien;
	ELSE
		error:=nohay;
	END;
END SacarBolsa;
		
	
 PROCEDURE DestruirBolsa(VAR b:TBolsa);
 VAR
 	vacia:BOOLEAN;
 	ptr:TBolsa;
 BEGIN
	vacia:=BolsaVacia(b);
	WHILE NOT vacia DO
		ptr:=b;
		b:=b^.sig;
		DISPOSE (ptr);
		vacia:=BolsaVacia(b);
	END;
END DestruirBolsa;

END MBolsa.
 	
